Digest::MD5 - Crystal 0.35.1

# class Digest::MD5

- Digest::MD5
- Digest::Base
- Reference
- Object

##
Overview

Implements the MD5 digest algorithm.

Warning: MD5 is no longer a cryptographically secure hash, and should not be used in security-related components, like password hashing. For passwords, see `Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via `OpenSSL::Digest.new("SHA256")`.

##
Defined in:

##
Constant Summary

S11 = `7`
S12 = `12`
S13 = `17`
S14 = `22`
S21 = `5`
S22 = `9`
S23 = `14`
S24 = `20`
S31 = `4`
S32 = `11`
S33 = `16`
S34 = `23`
S41 = `6`
S42 = `10`
S43 = `15`
S44 = `21`

##
Constructors

- .new

##
Class Method Summary

- .base64digest(data) : String

  Returns the base64-encoded hash of data.

- .base64digest(& : self -> _) : String

  Yields a context object with an `#update(data : String | Bytes)` method available.

- .digest(data)

  Returns the hash of data.

- .digest(& : self -> ) : Bytes

  Yields an instance of `self` which can receive calls to `#update(data : String | Bytes)` and returns the finalized digest afterwards.

- .hexdigest(data) : String

  Returns the hexadecimal representation of the hash of data.

- .hexdigest(& : self -> ) : String

  Yields a context object with an `#update(data : String | Bytes)` method available.

##
Instance Method Summary

- #digest_size : Int32

  Returns the digest output size in bytes.

### Instance methods inherited from class `Digest::Base`

digest : Bytes digest, digest_size : Int32 digest_size, final(dst : Bytes) : Bytes
final : Bytes final, final_impl(dst : Bytes) : Nil final_impl, hexdigest : String hexdigest, reset : self reset, reset_impl : Nil reset_impl, update(data : Bytes) : self
update(data) : self update, update_impl(data : Bytes) : Nil update_impl

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(*values : Object) : Bool
in?(collection) : Bool in?, inspect : String
inspect(io : IO) : Nil inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(io : IO, indent : String = " ")
to_pretty_json(indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new #

##
Class Method Detail

def self.base64digest(data) : String #

Returns the base64-encoded hash of data.

    require "digest/sha1"

    Digest::SHA1.base64digest("foo") # => "C+7Hteo/D9vJXQ3UfzxbwnXaijM="

def self.base64digest(& : self -> _) : String #

Yields a context object with an `#update(data : String | Bytes)` method available. Returns the resulting digest in base64 representation afterwards.

    require "digest/sha1"

    Digest::SHA1.base64digest do |ctx|
      ctx.update "f"
      ctx.update "oo"
    end
    # => "C+7Hteo/D9vJXQ3UfzxbwnXaijM="

def self.digest(data) #

Returns the hash of data. data must respond to `#to_slice`.

def self.digest(& : self -> ) : Bytes #

Yields an instance of `self` which can receive calls to `#update(data : String | Bytes)` and returns the finalized digest afterwards.

    require "digest/md5"

    digest = Digest::MD5.digest do |ctx|
      ctx.update "f"
      ctx.update "oo"
    end
    digest.to_slice.hexstring # => "acbd18db4cc2f85cedef654fccc4a4d8"

def self.hexdigest(data) : String #

Returns the hexadecimal representation of the hash of data.

    require "digest/md5"

    Digest::MD5.hexdigest("foo") # => "acbd18db4cc2f85cedef654fccc4a4d8"

def self.hexdigest(& : self -> ) : String #

Yields a context object with an `#update(data : String | Bytes)` method available. Returns the resulting digest in hexadecimal representation afterwards.

    require "digest/md5"

    Digest::MD5.hexdigest("foo") # => "acbd18db4cc2f85cedef654fccc4a4d8"
    Digest::MD5.hexdigest do |ctx|
      ctx.update "f"
      ctx.update "oo"
    end
    # => "acbd18db4cc2f85cedef654fccc4a4d8"

##
Instance Method Detail

def digest_size : Int32 #
Description copied from class Digest::Base

Returns the digest output size in bytes.